# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free
%define namedversion    0.1.0-SNAPSHOT
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           ops4j-pax-coin
Summary:        Pax Coin configuration agents
Url:            http://team.ops4j.org/wiki/display/~adreghiciu@gmail.com/Pax+Coin
Version:        0.1.0
Release:        2%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-pax-coin-0.1.0.tgz
# svn export https://scm.ops4j.org/repos/ops4j/laboratory/users/adreghiciu/pax/coin/ ops4j-pax-coin-0.1.0
# tar czf ../SOURCES/ops4j-pax-coin-0.1.0.tgz ops4j-pax-coin-0.1.0/
 
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:         ops4j-pax-coin-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-bundle-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  easymock
BuildRequires:  junit

BuildRequires:  apache-commons-configuration
BuildRequires:  ops4j-base
BuildRequires:  ops4j-pax-swissbox
BuildRequires:  org.osgi.core
BuildRequires:  org.osgi.compendium


Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  apache-commons-configuration
Requires:  ops4j-base
Requires:  ops4j-pax-swissbox
Requires:  org.osgi.core
Requires:  org.osgi.compendium

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Pax Coin are a set of configuration agents for OSGi that can
use configurations from divers sources and formats.
Out of the box Pax Coin supports the following configurations
sources:
* File System,
* Bundle,
* Service Registry
* By using Apache Commons Configuration format the source of
  configuration is extended further with built in support for
  Properties files, XML documents, Windows INI files,
  Property list files (plist), JNDI, JDBC, System Properties
  and any other source you may develop are already had
  developed by yourself.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
cp %{SOURCE1} settings.xml
%patch0 -b .sav0

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.ops4j.pax coin %{namedversion} JPP/%{name} coin
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-coin.pom

install -m 644 adapter/target/pax-coin-adapter-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/adapter-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-adapter %{namedversion} JPP/%{name} adapter
install -m 644 adapter/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-adapter.pom

install -m 644 provider-bundle-content/target/pax-coin-provider-bundle-content-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-bundle-content-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-provider-bundle-content %{namedversion} JPP/%{name} provider-bundle-content
install -m 644 provider-bundle-content/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-provider-bundle-content.pom

install -m 644 provider-file-system/target/pax-coin-provider-file-system-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-bundle-content-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-provider-file-system %{namedversion} JPP/%{name} provider-file-system
install -m 644 provider-file-system/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-provider-file-system.pom

install -m 644 provider-scanner/target/pax-coin-provider-scanner-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-scanner-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-provider-scanner %{namedversion} JPP/%{name} provider-scanner
install -m 644 provider-scanner/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-provider-scanner.pom

install -m 644 provider-service-registry/target/pax-coin-provider-service-registry-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-service-registry-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-provider-service-registry %{namedversion} JPP/%{name} provider-service-registry
install -m 644 provider-service-registry/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-provider-service-registry.pom

install -m 644 repository/target/pax-coin-repository-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/repository-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-repository %{namedversion} JPP/%{name} repository
install -m 644 repository/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-repository.pom

install -m 644 service/target/pax-coin-service-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/service-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-service %{namedversion} JPP/%{name} service
install -m 644 service/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-service.pom

install -m 644 spi/target/pax-coin-spi-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/spi-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-spi %{namedversion} JPP/%{name} spi
install -m 644 spi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spi.pom

install -m 644 wrapped-commons-configuration/target/pax-coin-wrapped-commons-configuration-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/wrapped-commons-configuration-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin pax-coin-wrapped-commons-configuration %{namedversion} JPP/%{name} wrapped-commons-configuration
install -m 644 wrapped-commons-configuration/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-wrapped-commons-configuration.pom

%add_to_maven_depmap org.ops4j.pax.coin samples %{namedversion} JPP/%{name} samples
install -m 644 samples/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples.pom

install -m 644 samples/samples-plugins/target/samples-plugins-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/samples-plugins-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin.samples samples-plugins %{namedversion} JPP/%{name} samples-plugins
install -m 644 samples/samples-plugins/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples-plugins.pom

install -m 644 samples/samples-rs-bc-custom-location/target/samples-rs-bc-custom-location-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/samples-rs-bc-custom-location-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin.samples samples-rs-bc-custom-location %{namedversion} JPP/%{name} samples-rs-bc-custom-location
install -m 644 samples/samples-rs-bc-custom-location/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples-rs-bc-custom-location.pom

install -m 644 samples/samples-rs-bc-default-location/target/samples-rs-bc-default-location-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/samples-rs-bc-default-location-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.coin.samples samples-rs-bc-default-location %{namedversion} JPP/%{name} samples-rs-bc-default-location
install -m 644 samples/samples-rs-bc-default-location/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples-rs-bc-default-location.pom

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Wed Sep 19 2012 Ralph Apel <r.apel at r-apel.de> 0:0.1.0-2
- 0.1.0 standalone

